package cz.zweistein.df.soundsense.player;

import java.util.logging.Logger;

import cz.zweistein.df.soundsense.config.Sound;
import cz.zweistein.df.soundsense.config.SoundFile;
import cz.zweistein.df.soundsense.util.LoggerSource;

public class MP3Thread implements Runnable {
	private static Logger logger = LoggerSource.logger;
	
	private PlayerManager managerCallback;
	private Sound sound;
	
	public MP3Thread(PlayerManager manager, Sound sound) {
		this.managerCallback = manager;
		this.sound = sound;
	}

	@Override
	public void run() {
		managerCallback.mp3ThreadPlayingStartCallback();
		try {
			
			logger.finest("Concurent sounds: "+managerCallback.concurentSounds);
			SoundFile soundFile = sound.getSoundFile();
			SPIPlayer player = new SPIPlayer();
			player.setMasterGain(soundFile.getVolumeAdjustment());
			
			logger.fine("Playing "+soundFile.getFileName());
			player.play(soundFile.getFileName());
			logger.fine("Finished "+soundFile.getFileName());
			
		} catch (Exception e) {
			logger.severe("Exception :"+e+": "+e.toString());
		} finally {
			managerCallback.mp3ThreadPlayingEndCallback();
		}
	}

}
