package cz.zweistein.df.soundsense.util;

import java.io.IOException;
import java.util.logging.Logger;
import java.util.regex.Pattern;

import cz.zweistein.df.soundsense.config.Sound;
import cz.zweistein.df.soundsense.config.SoundsXML;
import cz.zweistein.df.soundsense.log.LogReader;

public class MissingMessagesTool {
	
	private static Logger logger = LoggerSource.logger;
	
	public static void main(String[] args) {
		
		try {
			
			String logFile = "../gamelog.txt";
			String soundsConfig = "./packs/";
			
			if (args.length > 0) {
				logFile = args[0];
			}
			if (args.length > 1) {
				soundsConfig = args[1];
			}
			
			logger.info("MissingMessagesTool for SoundSense is starting...");
			logger.info("Loading theme packs from "+soundsConfig);
			SoundsXML soundsXML = new SoundsXML(soundsConfig);
			logger.info("Done loading "+soundsConfig+", loaded "+soundsXML.getSounds().size()+" items.");
			
			logger.info("Attempting to open "+logFile);
			LogReader logReader = new LogReader(logFile, false);
			logger.info("Parsing "+logFile);
			
			while (true) {
				String nextLine = logReader.getNextLine();
				
				boolean matched = false;
				for (Sound sound: soundsXML.getSounds()) {
					
					if (Pattern.matches(sound.getLogPattern(), nextLine)) {
						matched = true;
						break;
					}
				}
				if (matched == false) {
					logger.info(nextLine);
				}
				
			}
			
		} catch (IOException e) {
			logger.severe("Exception :"+e+": "+e.toString());
		}
		
	}

}
